/* p4wp4.h - all p4 headers */

# define NEED_FCNTL

# ifdef OS_NT
# define NEED_GETPID
# define NEED_CHDIR
# endif // OS_NT

/* clientapi.h gets most published api headers */

#include <clientapi.h>

# ifdef OS_NT
# include <winsvc.h>
# include <ntservice.h>
# undef GetMessage
# endif // OS_NT

/* All the other internal utilities used by p4web */

#include <strops.h>
#include <strarray.h>
#include <strtable.h>

#include <threading.h>

#include <netportparser.h>
#include <netconnect.h>
#include <netbuffer.h>
#include <web822.h>

#include <errorlog.h>
#include <errornum.h>

#include <options.h>
#include <pathsys.h>
#include <debug.h>
#include <enviro.h>
#include <diff.h>
#include <spec.h>
#include <ident.h>
#include <hostenv.h>
#include <datetime.h>

#include <runcmd.h>

/* system's time.h */

#include <time.h>

#include <i18napi.h>
#include <charcvt.h>
#include <charset.h>
#include <charman.h>

/* P4Web's Information Flag defines */

#define	INFO_FLAGS	"cn"

/* P4Web's Security Flag defines */

#define SEC_FLAGS	"aBCDEFGhiLNPqrswx"

#define FLG_DISALLOW_CHG_CLIENTS	0x0000001
#define FLG_ALLOW_UNOWNED_CLIENTS	0x0000002
#define FLG_ALLOW_ALL_CLIENTS		0x0000004
#define FLG_ALLOW_CREATE_CLIENTS	0x0000008
#define FLG_ALLOW_EDIT_CLIENTROOT	0x0000010
#define FLG_SHOW_STARTUP_FLAGS		0x0000020
#define FLG_ALLOW_NOHOST_CLIENTS	0x0000040
#define FLG_DISALLOW_REVHIST_INTEG	0x0000080
#define FLG_DISALLOW_INTEG			0x0000100
#define FLG_ALLOW_CR8CHG_SYMLINKS	0x0000800
#define FLG_ALLOW_NULL_ROOT			0x0002000
#define FLG_ALLOW_DOTDOT_ROOT		0x0008000
#define FLG_DONT_SHOW_REVHIST		0x0010000
#define FLG_DISALLOW_RAW_CMDS		0x0020000
#define FLG_USE_HTTPS				0x0040000
#define FLG_DONT_SHOW_WKSP_LINKS	0x0400000
#define FLG_DONT_SHOW_EMAIL_ADDR	0x0800000

#define	SEC_DISALLOW_CHG_CLIENTS	(fRequest.GetSecurityFlags() & FLG_DISALLOW_CHG_CLIENTS)
#define	SEC_ALLOW_UNOWNED_CLIENTS	(fRequest.GetSecurityFlags() & FLG_ALLOW_UNOWNED_CLIENTS)
#define	SEC_ALLOW_ALL_CLIENTS		(fRequest.GetSecurityFlags() & FLG_ALLOW_ALL_CLIENTS)
#define SEC_ALLOW_CREATE_CLIENTS	(fRequest.GetSecurityFlags() & FLG_ALLOW_CREATE_CLIENTS)
#define SEC_ALLOW_EDIT_CLIENTROOT	(fRequest.GetSecurityFlags() & FLG_ALLOW_EDIT_CLIENTROOT)
#define SEC_SHOW_STARTUP_FLAGS		(fRequest.GetSecurityFlags() & FLG_SHOW_STARTUP_FLAGS)
#define SEC_ALLOW_NOHOST_CLIENTS	(fRequest.GetSecurityFlags() & FLG_ALLOW_NOHOST_CLIENTS)
#define SEC_DISALLOW_REVHIST_INTEG	(fRequest.GetSecurityFlags() & FLG_DISALLOW_REVHIST_INTEG)
#define SEC_DISALLOW_INTEG			(fRequest.GetSecurityFlags() & FLG_DISALLOW_INTEG)
#define SEC_ALLOW_CR8CHG_SYMLINKS	(fRequest.GetSecurityFlags() & FLG_ALLOW_CR8CHG_SYMLINKS)
#define SEC_ALLOW_NULL_ROOT			(fRequest.GetSecurityFlags() & FLG_ALLOW_NULL_ROOT)
#define SEC_ALLOW_DOTDOT_ROOT		(fRequest.GetSecurityFlags() & FLG_ALLOW_DOTDOT_ROOT)
#define	SEC_DONT_SHOW_REVHIST		(fRequest.GetSecurityFlags() & FLG_DONT_SHOW_REVHIST)
#define SEC_DISALLOW_RAW_CMDS		(fRequest.GetSecurityFlags() & FLG_DISALLOW_RAW_CMDS)
#define SEC_USE_HTTPS				(fRequest.isHTTPS())
#define SEC_DONT_SHOW_WKSP_LINKS	(fRequest.GetSecurityFlags() & FLG_DONT_SHOW_WKSP_LINKS)
#define SEC_DONT_SHOW_EMAIL_ADDR	(fRequest.GetSecurityFlags() & FLG_DONT_SHOW_EMAIL_ADDR)
