//
// Copyright 2000 Perforce Software.  All rights reserved.
//
// This file is part of Perforce - the FAST SCM System.
//
// p4wBranchView:
//   Generates the branch -o  command for the branch pane


#include <stdlib.h>
#include <string.h>

#include <p4wp4.h>

#include "p4wView.h"
#include "p4wBranchView.h"

#include "p4wMenuPane.h"
#include "p4wBranchPane.h"


p4wBranchView::p4wBranchView( p4wRequest & Request )
	: p4wView(Request)
{
	//
	// Set the short and the long versions of the title
	
	fShortTitle.Set( "Branch Spec Detail" );
	fFullTitle << "Branch " << fRequest.GetURL();
}

p4wBranchView::~p4wBranchView()
{
}

void p4wBranchView::RenderContent()
{
	//
	// Generate a branch -o command and send it to the branch pane
	
	p4wBranchPane branchPane( *this, fRequest, 0 );
	
	fRequest.p4Arg( "-o" );
	if( fRequest.GetURL().Length() != 0 )
		fRequest.p4Arg( fRequest.GetURL().Text() );
		
	fRequest.p4( "branch", 0, 0, &branchPane );

	fRequest.p4Wait();
}

void p4wBranchView::RenderMenu()
{
	//
	// Draw the menu bar
	 
	p4wMenuPane menuPane( *this, fRequest, "branch" );
	menuPane.Render( NULL );
}
