// Copyright 1999 (c) by Perforce Software, Inc.  All rights reserved.
//
// p4wClientEditView:
//   The client edit view.


// -------------------------------------
// Includes
//
#include <stdlib.h>
#include <string.h>

#include <p4wp4.h>

#include "p4wView.h"
#include "p4wMenuPane.h"
#include "p4wClientEditView.h"

#include "p4wClientPane.h"



//
// -------------------------------------
// Constructors and destructor.
//
p4wClientEditView::p4wClientEditView(p4wRequest & Request)
	: p4wView(Request)
{
	//
	// Set the short and the long versions of the title
	
	fShortTitle.Set( "Edit Client Spec" );
	fFullTitle << "Edit Client Spec " << fRequest.GetURL();
}

p4wClientEditView::~p4wClientEditView()
{
}



// -------------------------------------
// Control item render functions.
//

void p4wClientEditView::RenderContent()
{
	//
	// Send the client edit pane.
	p4wClientPane clientPane(*this, fRequest, 1);
	if( fRequest.GetURL().Length() == 0 || !fRequest.isLocalRequest() ) {
		const char *clientPaneArgs[] = { "-o" };
		fRequest.p4("client", 1, clientPaneArgs, &clientPane);
	} else {
		const char *clientPaneArgs[] = { "-o", fRequest.GetURL().Text() };
		fRequest.p4("client", 2, clientPaneArgs, &clientPane);
	}

	//
	// Wait for the pane to draw.
	fRequest.p4Wait();
}

void p4wClientEditView::RenderMenu()
{
	//
	// Draw the menu bar
	p4wMenuPane menuPane(*this, fRequest, "editclient");
	menuPane.Render(NULL);
}
