// Copyright 1999 (c) by Perforce Software, Inc.  All rights reserved.
//
// p4wDeleteProcessorView:
//   The Delete processor view.


// -------------------------------------
// Includes
//
#include <stdlib.h>
#include <string.h>

#include <p4wp4.h>

#include "p4wDeleteProcessorView.h"

#include "p4wCmdPane.h"

//
// -------------------------------------
// Constructors and destructor.
//
p4wDeleteProcessorView::p4wDeleteProcessorView(p4wRequest & Request)
	: p4wRunView(Request)
{
	//
	// Parse formAction to see if this is a redisplay request

	ProcessFormAction();		
	fAc = AC_DELETEFRM;
	
	//
	// Set the short and the long versions of the title.
	// If there is no POST data the title is "Error".
	
	if( !ProcessForm() ) {
		fShortTitle.Set( "Error" );
		fFullTitle.Set( "Error" );
		return;
	}
		
	fShortTitle.Set( "Command Result" );
	fFullTitle.Set( "Delete Result" );
}

p4wDeleteProcessorView::~p4wDeleteProcessorView()
{
}

// -------------------------------------
// Control item render functions.
//

void p4wDeleteProcessorView::RenderContent()
{
	//
	// Issue edit command (passing the results through a 
	// CmdPane).

	if( !ProcessForm() ) {
		RenderError("Requested URL is invalid in this context.");
		return;
	}

	//
	// Parse options and build up the command args

	title.Set("Delete ");

	if( specTable.GetVar("OptionChg") ) {
		ArgAndTitle( "-c" );
		ArgAndTitle( *specTable.GetVar("changelistVal") );
	}
	
	//
	// Process the files. If this returned an error, don't issue command

	if( !AddFileArgs() ) 
		return;
	
	// Run Delete.

	p4wCmdPane cmdPane(*this, fRequest, title.Text());
	fRequest.p4("delete", 0, 0, &cmdPane);
	fRequest.p4Wait();
}

