//
// Copyright 2000 Perforce Software.  All rights reserved.
//
// This file is part of Perforce - the FAST SCM System.
//
// p4wLabelView:
//   Generates the label command for the label pane


#include <stdlib.h>
#include <string.h>

#include <p4wp4.h>

#include "p4wView.h"
#include "p4wLabelView.h"

#include "p4wMenuPane.h"
#include "p4wLabelPane.h"


p4wLabelView::p4wLabelView( p4wRequest & Request )
	: p4wView(Request)
{
	//
	// Set the short and the long versions of the title
	
	fShortTitle.Set( "Label Spec Detail" );
	fFullTitle << "Label " << fRequest.GetURL();
}

p4wLabelView::~p4wLabelView()
{
}

void p4wLabelView::RenderContent()
{
	//
	// Generate a label -o command and send it to the label pane
	
	p4wLabelPane labelPane( *this, fRequest, 0 );
	
	fRequest.p4Arg( "-o" );
	if( fRequest.GetURL().Length() != 0 )
		fRequest.p4Arg( fRequest.GetURL().Text() );
		
	fRequest.p4( "label", 0, 0, &labelPane );

	fRequest.p4Wait();
}

void p4wLabelView::RenderMenu()
{
	//
	// Draw the menu bar
	 
	p4wMenuPane menuPane( *this, fRequest, "label" );
	menuPane.Render( NULL );
}
