//
// Copyright 2000 Perforce Software.  All rights reserved.
//
// This file is part of Perforce - the FAST SCM System.
//
// p4wLabelsView:
//   Run labels command for the labels pane


// -------------------------------------
// Includes
//
#include <stdlib.h>
#include <string.h>

#include <p4wp4.h>

#include "p4wView.h"
#include "p4wLabelsView.h"

#include "p4wLabelsPane.h"
#include "p4wMenuPane.h"


p4wLabelsView::p4wLabelsView( p4wRequest & Request )
	: p4wView(Request)
{
	//
	// Set the short and the long versions of the title
	
	fShortTitle << "Labels";	
	fFullTitle << "Labels";
}

p4wLabelsView::~p4wLabelsView()
{
}



// -------------------------------------
// Control item render functions.
//

void p4wLabelsView::RenderContent()
{
	//
	// See if we have a dyn arg requesting AC_LABELSPATH

	const StrPtr *lfl = fRequest.GetDynArg( "lfl" );
	if (lfl && (*(lfl->Text()) & 2))
		fRequest.SetCmd(AC_LABELSPATH);

	//
	// Send the labels command to the labels pane.
	// Pass the path as an argument if this is an AC_LABELSPATH
	// request.
				
	p4wLabelsPane labelsPane( *this, fRequest );
	
	if( fRequest.GetCmd() == AC_LABELSPATH ) {
		AllCommands rt = fRequest.GetLastReturnType();
		StrBuf path;
		path.Set( fRequest.GetReturnURL( rt ).Text() );
		if( rt == AC_PATHBROWSER )
			path << "...";
			
		fRequest.p4Arg( path.Text() );
	}

	fRequest.p4( "labels", 0, 0, &labelsPane );
	fRequest.p4Wait();
}

void p4wLabelsView::RenderMenu()
{
	//
	// Draw the menu bar using the appropriate help file
	
	p4wMenuPane menuPane( *this, fRequest, "label" );
	menuPane.Render( NULL );
}
