// Copyright 1999 (c) by Perforce Software, Inc.  All rights reserved.
//
// p4wMenuProcessorView:
//   The menu bar processor view.

#ifndef p4wMenuProcessorView_H
#define p4wMenuProcessorView_H


//
// Includes
#include "p4wView.h"
#include "p4wAllCommands.h"
#include "p4wMenuPaneOpts.h"

//
// p4wMenuProcessorView class
class p4wMenuProcessorView : public p4wView {

public:
	//
	// Constructors and destructor.
				p4wMenuProcessorView(p4wRequest & Request, 
					AllCommands cmd);
	virtual			~p4wMenuProcessorView();

	// Control item render functions.

	virtual	void		RenderContent();
	virtual void		RenderMenu();
	virtual int		RenderUpdateOK();

	void	SetErrorMsg(char *emsg) { fErrorMsg.Set(emsg); }
	
private:

	void			doPendingChanges(p4wPane *cmdPane);
	void			doFstat(p4wPane *cmdPane);

	PathMenuType		fMenuAction;
	AllCommands		fCommand;
	StrBuf			fMenuTitle;
	StrBuf			fErrorMsg;
	
};

#endif // p4wMenuProcessorView_H

