// Copyright 1999 (c) by Perforce Software, Inc.  All rights reserved.
//
// p4wUserEditView:
//   The user edit view.


// -------------------------------------
// Includes
//
#include <stdlib.h>
#include <string.h>

#include <p4wp4.h>

#include "p4wView.h"
#include "p4wUserEditView.h"

#include "p4wMenuPane.h"
#include "p4wUserPane.h"



//
// -------------------------------------
// Constructors and destructor.
//
p4wUserEditView::p4wUserEditView(p4wRequest & Request)
	: p4wView(Request)
{
	//
	// Set the short and the long versions of the title
	
	fShortTitle.Set( "Edit User" );
	fFullTitle << "Edit User " << fRequest.GetURL();
}

p4wUserEditView::~p4wUserEditView()
{
}



// -------------------------------------
// Control item render functions.
//

void p4wUserEditView::RenderContent()
{
	//
	// Send the user edit view pane.
	
	p4wUserPane userPane(*this, fRequest,1);
	
	if( fRequest.GetURL().Length() == 0 ) {
		const char *userPaneArgs[] = { "-o" };
		fRequest.p4("user", 1, userPaneArgs, &userPane);
	} else {
		const char *userPaneArgs[] = { "-o", fRequest.GetURL().Text() };
		fRequest.p4("user", 2, userPaneArgs, &userPane);
	}

	//
	// Wait for the pane to draw.
	
	fRequest.p4Wait();
}

void p4wUserEditView::RenderMenu()
{
	//
	// Draw the menu bar
	
	p4wMenuPane menuPane(*this, fRequest, "edituser");
	menuPane.Render(NULL);
}
